// Generated from libavfilter/opencl/colorspace_common.cl
const char *ff_source_colorspace_common_cl =
"/*\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"#define ST2084_MAX_LUMINANCE 10000.0f\n"
"#define ST2084_M1 0.1593017578125f\n"
"#define ST2084_M2 78.84375f\n"
"#define ST2084_C1 0.8359375f\n"
"#define ST2084_C2 18.8515625f\n"
"#define ST2084_C3 18.6875f\n"
"\n"
"#define ARIB_B67_A 0.17883277f\n"
"#define ARIB_B67_B 0.28466892f\n"
"#define ARIB_B67_C 0.55991073f\n"
"\n"
"#define FLOAT_EPS 1e-6f\n"
"\n"
"#if chroma_loc == 1\n"
"    #define chroma_sample(a,b,c,d) (((a) + (c)) * 0.5f)\n"
"#elif chroma_loc == 3\n"
"    #define chroma_sample(a,b,c,d) (a)\n"
"#elif chroma_loc == 4\n"
"    #define chroma_sample(a,b,c,d) (((a) + (b)) * 0.5f)\n"
"#elif chroma_loc == 5\n"
"    #define chroma_sample(a,b,c,d) (c)\n"
"#elif chroma_loc == 6\n"
"    #define chroma_sample(a,b,c,d) (((c) + (d)) * 0.5f)\n"
"#else\n"
"    #define chroma_sample(a,b,c,d) (((a) + (b) + (c) + (d)) * 0.25f)\n"
"#endif\n"
"\n"
"float get_luma_dst(float3 c) {\n"
"    return luma_dst.x * c.x + luma_dst.y * c.y + luma_dst.z * c.z;\n"
"}\n"
"\n"
"float4 get_luma_dst4(float4 r4, float4 g4, float4 b4) {\n"
"    return luma_dst.x * r4 + luma_dst.y * g4 + luma_dst.z * b4;\n"
"}\n"
"\n"
"/*\n"
"float get_luma_src(float3 c) {\n"
"    return luma_src.x * c.x + luma_src.y * c.y + luma_src.z * c.z;\n"
"}\n"
"\n"
"float4 get_luma_src4(float4 r4, float4 g4, float4 b4) {\n"
"    return luma_src.x * r4 + luma_src.y * g4 + luma_src.z * b4;\n"
"}\n"
"*/\n"
"\n"
"float3 get_chroma_sample(float3 a, float3 b, float3 c, float3 d) {\n"
"    return chroma_sample(a, b, c, d);\n"
"}\n"
"\n"
"// linearizer for PQ/ST2084\n"
"float eotf_st2084_common(float x) {\n"
"    x = fmax(x, 0.0f);\n"
"    float xpow = native_powr(x, 1.0f / ST2084_M2);\n"
"    float num = fmax(xpow - ST2084_C1, 0.0f);\n"
"    float den = fmax(ST2084_C2 - ST2084_C3 * xpow, FLOAT_EPS);\n"
"    x = native_powr(num / den, 1.0f / ST2084_M1);\n"
"    return x;\n"
"}\n"
"\n"
"float eotf_st2084(float x) {\n"
"    return eotf_st2084_common(x) * pq_max_lum_div_ref_white;\n"
"}\n"
"\n"
"// delinearizer for PQ/ST2084\n"
"float inverse_eotf_st2084_common(float x) {\n"
"    x = fmax(x, 0.0f);\n"
"    float xpow = native_powr(x, ST2084_M1);\n"
"#if 0\n"
"    // Original formulation from SMPTE ST 2084:2014 publication.\n"
"    float num = ST2084_C1 + ST2084_C2 * xpow;\n"
"    float den = 1.0f + ST2084_C3 * xpow;\n"
"    return native_powr(num / den, ST2084_M2);\n"
"#else\n"
"    // More stable arrangement that avoids some cancellation error.\n"
"    float num = (ST2084_C1 - 1.0f) + (ST2084_C2 - ST2084_C3) * xpow;\n"
"    float den = 1.0f + ST2084_C3 * xpow;\n"
"    return native_powr(1.0f + num / den, ST2084_M2);\n"
"#endif\n"
"}\n"
"\n"
"float inverse_eotf_st2084(float x) {\n"
"    x *= ref_white_div_pq_max_lum;\n"
"    return inverse_eotf_st2084_common(x);\n"
"}\n"
"\n"
"float4 eotf_st2084x4(float4 x) {\n"
"    x.x = eotf_st2084_common(x.x);\n"
"    x.y = eotf_st2084_common(x.y);\n"
"    x.z = eotf_st2084_common(x.z);\n"
"    x.w = eotf_st2084_common(x.w);\n"
"    return x * pq_max_lum_div_ref_white;\n"
"}\n"
"\n"
"float4 inverse_eotf_st2084x4(float4 x) {\n"
"    x *= ref_white_div_pq_max_lum;\n"
"    x.x = inverse_eotf_st2084_common(x.x);\n"
"    x.y = inverse_eotf_st2084_common(x.y);\n"
"    x.z = inverse_eotf_st2084_common(x.z);\n"
"    x.w = inverse_eotf_st2084_common(x.w);\n"
"    return x;\n"
"}\n"
"\n"
"float ootf_1_2(float x) {\n"
"    return x > 0.0f ? native_powr(x, 1.2f) : x;\n"
"}\n"
"\n"
"float inverse_ootf_1_2(float x) {\n"
"    return x > 0.0f ? native_powr(x, 1.0f / 1.2f) : x;\n"
"}\n"
"\n"
"float oetf_arib_b67(float x) {\n"
"    x = fmax(x, 0.0f);\n"
"    return x <= (1.0f / 12.0f)\n"
"           ? native_sqrt(3.0f * x)\n"
"           : (ARIB_B67_A * native_log(12.0f * x - ARIB_B67_B) + ARIB_B67_C);\n"
"}\n"
"\n"
"float inverse_oetf_arib_b67(float x) {\n"
"    x = fmax(x, 0.0f);\n"
"    return x <= 0.5f\n"
"           ? (x * x) * (1.0f / 3.0f)\n"
"           : (native_exp((x - ARIB_B67_C) / ARIB_B67_A) + ARIB_B67_B) * (1.0f / 12.0f);\n"
"}\n"
"\n"
"// linearizer for HLG/ARIB-B67\n"
"float eotf_arib_b67(float x) {\n"
"    return ootf_1_2(inverse_oetf_arib_b67(x)) * 5.0f;\n"
"}\n"
"\n"
"// delinearizer for HLG/ARIB-B67\n"
"float inverse_eotf_arib_b67(float x) {\n"
"    return oetf_arib_b67(inverse_ootf_1_2(x / 5.0f));\n"
"}\n"
"\n"
"// delinearizer for BT709, BT2020-10\n"
"float inverse_eotf_bt1886(float x) {\n"
"    return x > 0.0f ? native_powr(x, 1.0f / 2.4f) : 0.0f;\n"
"}\n"
"\n"
"#ifdef LUT_TRC\n"
"float linearize_lut(float x) {\n"
"    return lin_lut[clamp((int)(x * LUT_TRC), 0, LUT_TRC)];\n"
"}\n"
"#endif\n"
"\n"
"float3 yuv2rgb(float y, float u, float v) {\n"
"    y += mix(0.0f, input_quantization_offset, y > 0.0f);\n"
"    u += mix(0.0f, input_quantization_offset, u > 0.0f);\n"
"    v += mix(0.0f, input_quantization_offset, v > 0.0f);\n"
"#ifndef FULL_RANGE_IN\n"
"    y = input_y_scale * y - 0.07305936073f;\n"
"    u = input_uv_scale * u - 0.5714285714f;\n"
"    v = input_uv_scale * v - 0.5714285714f;\n"
"#else\n"
"    u -= 0.5f; v -= 0.5f;\n"
"#endif\n"
"    float r = y * rgb_matrix[0] + u * rgb_matrix[1] + v * rgb_matrix[2];\n"
"    float g = y * rgb_matrix[3] + u * rgb_matrix[4] + v * rgb_matrix[5];\n"
"    float b = y * rgb_matrix[6] + u * rgb_matrix[7] + v * rgb_matrix[8];\n"
"    return (float3)(r, g, b);\n"
"}\n"
"\n"
"float3 yuv2lrgb(float3 yuv) {\n"
"    float3 rgb = yuv2rgb(yuv.x, yuv.y, yuv.z);\n"
"#ifdef linearize\n"
"    float r = linearize(rgb.x);\n"
"    float g = linearize(rgb.y);\n"
"    float b = linearize(rgb.z);\n"
"    return (float3)(r, g, b);\n"
"#else\n"
"    return rgb;\n"
"#endif\n"
"}\n"
"\n"
"float3 rgb2yuv(float r, float g, float b) {\n"
"    float y = r*yuv_matrix[0] + g*yuv_matrix[1] + b*yuv_matrix[2];\n"
"    float u = r*yuv_matrix[3] + g*yuv_matrix[4] + b*yuv_matrix[5];\n"
"    float v = r*yuv_matrix[6] + g*yuv_matrix[7] + b*yuv_matrix[8];\n"
"#ifndef FULL_RANGE_OUT\n"
"  #ifdef RESCALE_LIMITED_RANGE_OUTPUT\n"
"    y = floor(((219.0f * y + 16.0f) * 256.0f) + 0.5f) / 65535.0f;\n"
"    u = floor(((224.0f * u + 128.0f) * 256.0f) + 0.5f) / 65535.0f;\n"
"    v = floor(((224.0f * v + 128.0f) * 256.0f) + 0.5f) / 65535.0f;\n"
"  #else\n"
"    y = floor((219.0f * y + 16.0f) + 0.5f) / 255.0f;\n"
"    u = floor((224.0f * u + 128.0f) + 0.5f) / 255.0f;\n"
"    v = floor((224.0f * v + 128.0f) + 0.5f) / 255.0f;\n"
"  #endif\n"
"#else\n"
"    u += 0.5f; v += 0.5f;\n"
"#endif\n"
"    y -= mix(0.0f, output_quantization_offset, y > 0.0f);\n"
"    u -= mix(0.0f, output_quantization_offset, u > 0.0f);\n"
"    v -= mix(0.0f, output_quantization_offset, v > 0.0f);\n"
"    return (float3)(y, u, v);\n"
"}\n"
"\n"
"float rgb2y(float r, float g, float b) {\n"
"    float y = r*yuv_matrix[0] + g*yuv_matrix[1] + b*yuv_matrix[2];\n"
"#ifndef FULL_RANGE_OUT\n"
"  #ifdef RESCALE_LIMITED_RANGE_OUTPUT\n"
"    y = floor(((219.0f * y + 16.0f) * 256.0f) + 0.5f) / 65535.0f;\n"
"  #else\n"
"    y = floor((219.0f * y + 16.0f) + 0.5f) / 255.0f;\n"
"  #endif\n"
"#endif\n"
"    y -= mix(0.0f, output_quantization_offset, y > 0.0f);\n"
"    return y;\n"
"}\n"
"\n"
"float3 lrgb2yuv(float3 c) {\n"
"#ifdef delinearize\n"
"    float r = delinearize(c.x);\n"
"    float g = delinearize(c.y);\n"
"    float b = delinearize(c.z);\n"
"    return rgb2yuv(r, g, b);\n"
"#else\n"
"    return rgb2yuv(c.x, c.y, c.z);\n"
"#endif\n"
"}\n"
"\n"
"float lrgb2y(float3 c) {\n"
"#ifdef delinearize\n"
"    float r = delinearize(c.x);\n"
"    float g = delinearize(c.y);\n"
"    float b = delinearize(c.z);\n"
"    return rgb2y(r, g, b);\n"
"#else\n"
"    return rgb2y(c.x, c.y, c.z);\n"
"#endif\n"
"}\n"
"\n"
"float3 lrgb2lrgb(float3 c) {\n"
"#ifdef RGB2RGB_PASSTHROUGH\n"
"    return c;\n"
"#else\n"
"    float r = c.x, g = c.y, b = c.z;\n"
"    float rr = rgb2rgb[0] * r + rgb2rgb[1] * g + rgb2rgb[2] * b;\n"
"    float gg = rgb2rgb[3] * r + rgb2rgb[4] * g + rgb2rgb[5] * b;\n"
"    float bb = rgb2rgb[6] * r + rgb2rgb[7] * g + rgb2rgb[8] * b;\n"
"    return (float3)(rr, gg, bb);\n"
"#endif\n"
"}\n"
"\n"
"float3 rgb2lrgb(float3 c) {\n"
"#ifdef linearize\n"
"    float r = linearize(c.x);\n"
"    float g = linearize(c.y);\n"
"    float b = linearize(c.z);\n"
"    return (float3)(r, g, b);\n"
"#else\n"
"    return c;\n"
"#endif\n"
"}\n"
"\n"
"#ifdef DOVI_RESHAPE\n"
"float3 ycc2rgb(float y, float cb, float cr) {\n"
"    float r = y * rgb_matrix[0] + cb * rgb_matrix[1] + cr * rgb_matrix[2];\n"
"    float g = y * rgb_matrix[3] + cb * rgb_matrix[4] + cr * rgb_matrix[5];\n"
"    float b = y * rgb_matrix[6] + cb * rgb_matrix[7] + cr * rgb_matrix[8];\n"
"    return (float3)(r, g, b) + ycc2rgb_offset;\n"
"}\n"
"\n"
"float3 lms2rgb(float r, float g, float b) {\n"
"  #ifndef DOVI_PERF_TRADEOFF\n"
"    r = eotf_st2084_common(r);\n"
"    g = eotf_st2084_common(g);\n"
"    b = eotf_st2084_common(b);\n"
"  #endif\n"
"    float rr = r * lms2rgb_matrix[0] + g * lms2rgb_matrix[1] + b * lms2rgb_matrix[2];\n"
"    float gg = r * lms2rgb_matrix[3] + g * lms2rgb_matrix[4] + b * lms2rgb_matrix[5];\n"
"    float bb = r * lms2rgb_matrix[6] + g * lms2rgb_matrix[7] + b * lms2rgb_matrix[8];\n"
"  #ifndef DOVI_PERF_TRADEOFF\n"
"    rr = inverse_eotf_st2084_common(rr);\n"
"    gg = inverse_eotf_st2084_common(gg);\n"
"    bb = inverse_eotf_st2084_common(bb);\n"
"  #endif\n"
"    return (float3)(rr, gg, bb);\n"
"}\n"
"#endif\n"
"\n"
"#ifdef TONE_MODE_ITP\n"
"// The following assumes bt2020\n"
"void lrgb2ictcp(float4 r4, float4 g4, float4 b4, float4* i4, float4* ct4, float4* cp4) {\n"
"    float4 l4 = 0.412109375000000f * r4 + 0.523925781250000f * g4 + 0.063964843750000f * b4;\n"
"    float4 m4 = 0.166748046875000f * r4 + 0.720458984375000f * g4 + 0.112792968750000f * b4;\n"
"    float4 s4 = 0.024169921875000f * r4 + 0.075439453125000f * g4 + 0.900390625000000f * b4;\n"
"    l4 = inverse_eotf_st2084x4(l4);\n"
"    m4 = inverse_eotf_st2084x4(m4);\n"
"    s4 = inverse_eotf_st2084x4(s4);\n"
"    *i4 = 0.5f * l4 + 0.5f * m4;\n"
"    *ct4 = 1.613769531250000f * l4 - 3.323486328125000f * m4 + 1.709716796875000f * s4;\n"
"    *cp4 = 4.378173828125000f * l4 - 4.245605468750000f * m4 - 0.132568359375000f * s4;\n"
"}\n"
"\n"
"void ictcp2lrgb(float4 i4, float4 ct4, float4 cp4, float4* r4, float4* g4, float4* b4) {\n"
"    float4 ll4 = i4 + 0.008609037037933f * ct4 + 0.111029625003026f * cp4;\n"
"    float4 mm4 = i4 - 0.008609037037933f * ct4 - 0.111029625003026f * cp4;\n"
"    float4 ss4 = i4 + 0.560031335710679f * ct4 - 0.320627174987319f * cp4;\n"
"    ll4 = eotf_st2084x4(ll4);\n"
"    mm4 = eotf_st2084x4(mm4);\n"
"    ss4 = eotf_st2084x4(ss4);\n"
"    *r4 = 3.436606694333079f * ll4 - 2.506452118656270f * mm4 + 0.069845424323191f * ss4;\n"
"    *g4 = -0.791329555598929f * ll4 + 1.983600451792291f * mm4 - 0.192270896193362f * ss4;\n"
"    *b4 = -0.025949899690593f * ll4 - 0.098913714711726f * mm4 + 1.124863614402319f * ss4;\n"
"}\n"
"#endif\n"
"\n"
"float parabolic(float x, float t0, float x0, float y0) {\n"
"    float s = (y0 - t0) / native_sqrt(x0 - y0);\n"
"    float ox = t0 - s * s * 0.25f;\n"
"    float oy = t0 - s * native_sqrt(s * s * 0.25f);\n"
"    return (x < t0 ? x : s * native_sqrt(x - ox) + oy);\n"
"}\n"
"\n"
"float3 gamut_compress(float3 rgb) {\n"
"    // BT.709 boundary info\n"
"    #define cyan_limit 1.5187050250638159f\n"
"    #define magenta_limit 1.0750082769546088f\n"
"    #define yellow_limit 1.0887800403483898f\n"
"    #define cyan_threshold 1.050508660266247f\n"
"    #define magenta_threshold 0.940509816042432f\n"
"    #define yellow_threshold 0.9771607996420639f\n"
"\n"
"    // Achromatic axis\n"
"    float ac = fmax(fmax(rgb.x, rgb.y), rgb.z);\n"
"\n"
"    // Inverse RGB Ratios: distance from achromatic axis\n"
"    float3 d = ac == 0.0f ? (float3)(0.0f, 0.0f, 0.0f) : (ac - rgb) / fabs(ac);\n"
"\n"
"    // Compressed distance\n"
"    float3 cd = (float3)(\n"
"        parabolic(d.x, cyan_threshold, cyan_limit, 1.0f),\n"
"        parabolic(d.y, magenta_threshold, magenta_limit, 1.0f),\n"
"        parabolic(d.z, yellow_threshold, yellow_limit, 1.0f)\n"
"    );\n"
"\n"
"    // Inverse RGB Ratios to RGB\n"
"    float3 crgb = ac - cd * fabs(ac);\n"
"\n"
"    return crgb;\n"
"}\n"
;
