// Generated from libavfilter/opencl/scale.cl
const char *ff_source_scale_cl =
"/*\n"
" * Copyright (c) 2018 Gabriel Machado\n"
" * Copyright (c) 2021 NyanMisaka\n"
" *\n"
" * This file is part of FFmpeg.\n"
" *\n"
" * FFmpeg is free software; you can redistribute it and/or\n"
" * modify it under the terms of the GNU Lesser General Public\n"
" * License as published by the Free Software Foundation; either\n"
" * version 2.1 of the License, or (at your option) any later version.\n"
" *\n"
" * FFmpeg is distributed in the hope that it will be useful,\n"
" * but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
" * Lesser General Public License for more details.\n"
" *\n"
" * You should have received a copy of the GNU Lesser General Public\n"
" * License along with FFmpeg; if not, write to the Free Software\n"
" * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA\n"
" */\n"
"\n"
"__constant sampler_t sampler = (CLK_NORMALIZED_COORDS_FALSE |\n"
"                                CLK_ADDRESS_CLAMP_TO_EDGE   |\n"
"                                CLK_FILTER_NEAREST);\n"
"\n"
"__constant sampler_t sampler2 = (CLK_NORMALIZED_COORDS_FALSE |\n"
"                                 CLK_ADDRESS_NONE            |\n"
"                                 CLK_FILTER_NEAREST);\n"
"\n"
"__constant sampler_t d_sampler = (CLK_NORMALIZED_COORDS_TRUE |\n"
"                                  CLK_ADDRESS_REPEAT         |\n"
"                                  CLK_FILTER_NEAREST);\n"
"\n"
"#ifdef ENABLE_DITHER\n"
"float get_dithered_y(float y, float d) {\n"
"    return floor(y * dither_quantization + d + 0.5f / dither_size2) * 1.0f / dither_quantization;\n"
"}\n"
"#endif\n"
"\n"
"#ifdef CONV\n"
"__kernel void conv_yuv(__write_only image2d_t dst1,\n"
"                       __read_only  image2d_t src1,\n"
"                       __write_only image2d_t dst2,\n"
"                       __read_only  image2d_t src2\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"                      ,__write_only image2d_t dst3\n"
"#endif\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"                      ,__read_only  image2d_t src3\n"
"#endif\n"
"#ifdef ENABLE_DITHER\n"
"                      ,__read_only  image2d_t dither\n"
"#endif\n"
"                       )\n"
"{\n"
"    int xi = get_global_id(0);\n"
"    int yi = get_global_id(1);\n"
"    // each work item process four pixels\n"
"    int x = 2 * xi;\n"
"    int y = 2 * yi;\n"
"\n"
"#ifdef ENABLE_DITHER\n"
"    float2 ncoords = convert_float2((int2)(xi, yi)) *\n"
"        native_recip((float2)(get_image_width(dither), get_image_height(dither)));\n"
"#endif\n"
"\n"
"    if (xi < get_image_width(dst2) && yi < get_image_height(dst2)) {\n"
"        float y0 = read_imagef(src1, sampler, (int2)(x,     y)).x;\n"
"        float y1 = read_imagef(src1, sampler, (int2)(x + 1, y)).x;\n"
"        float y2 = read_imagef(src1, sampler, (int2)(x,     y + 1)).x;\n"
"        float y3 = read_imagef(src1, sampler, (int2)(x + 1, y + 1)).x;\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"        float u = read_imagef(src2, sampler, (int2)(xi, yi)).x;\n"
"        float v = read_imagef(src3, sampler, (int2)(xi, yi)).x;\n"
"#else\n"
"        float2 uv = read_imagef(src2, sampler, (int2)(xi, yi)).xy;\n"
"        float u = uv.x;\n"
"        float v = uv.y;\n"
"#endif\n"
"#ifdef ENABLE_DITHER\n"
"        float d = read_imagef(dither, d_sampler, ncoords).x;\n"
"        y0 = get_dithered_y(y0, d);\n"
"        y1 = get_dithered_y(y1, d);\n"
"        y2 = get_dithered_y(y2, d);\n"
"        y3 = get_dithered_y(y3, d);\n"
"#endif\n"
"        write_imagef(dst1, (int2)(x,     y), (float4)(y0, 0.0f, 0.0f, 1.0f));\n"
"        write_imagef(dst1, (int2)(x + 1, y), (float4)(y1, 0.0f, 0.0f, 1.0f));\n"
"        write_imagef(dst1, (int2)(x,     y + 1), (float4)(y2, 0.0f, 0.0f, 1.0f));\n"
"        write_imagef(dst1, (int2)(x + 1, y + 1), (float4)(y3, 0.0f, 0.0f, 1.0f));\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"        write_imagef(dst2, (int2)(xi, yi), (float4)(u, 0.0f, 0.0f, 1.0f));\n"
"        write_imagef(dst3, (int2)(xi, yi), (float4)(v, 0.0f, 0.0f, 1.0f));\n"
"#else\n"
"        write_imagef(dst2, (int2)(xi, yi), (float4)(u, v, 0.0f, 1.0f));\n"
"#endif\n"
"    }\n"
"}\n"
"#endif\n"
"\n"
"#ifdef NEIGHBOR\n"
"__kernel void neighbor(__write_only image2d_t dst1,\n"
"                       __read_only  image2d_t src1,\n"
"#ifdef ENABLE_DITHER\n"
"                       __read_only  image2d_t dither,\n"
"#endif\n"
"                                    int2      src_size)\n"
"{\n"
"    int xi = get_global_id(0);\n"
"    int yi = get_global_id(1);\n"
"\n"
"    int2 dst_pos = { xi, yi };\n"
"    float2 dst_size = { get_global_size(0), get_global_size(1) };\n"
"\n"
"    float2 src_coord = (convert_float2(dst_pos) + 0.5f) * convert_float2(src_size) * native_recip(dst_size);\n"
"    int2 src_pos = convert_int2(floor(src_coord - 0.5f));\n"
"\n"
"#ifdef ENABLE_DITHER\n"
"    float2 ncoords = convert_float2((int2)(xi, yi)) *\n"
"        native_recip((float2)(get_image_width(dither), get_image_height(dither)));\n"
"#endif\n"
"\n"
"    int2 read_pos = clamp(src_pos, 0, src_size - 1);\n"
"    float y = read_imagef(src1, sampler2, read_pos).x;\n"
"\n"
"#ifdef ENABLE_DITHER\n"
"    float d = read_imagef(dither, d_sampler, ncoords).x;\n"
"    y = get_dithered_y(y, d);\n"
"#endif\n"
"\n"
"    write_imagef(dst1, dst_pos, (float4)(y, 0.0f, 0.0f, 1.0f));\n"
"}\n"
"\n"
"__kernel void neighbor_uv(__write_only image2d_t dst2,\n"
"                          __read_only  image2d_t src2,\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"                          __write_only image2d_t dst3,\n"
"#endif\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"                          __read_only  image2d_t src3,\n"
"#endif\n"
"                                       int2      src_size)\n"
"{\n"
"    int2 dst_pos = { get_global_id(0), get_global_id(1) };\n"
"    float2 dst_size = { get_global_size(0), get_global_size(1) };\n"
"\n"
"    float2 src_coord = (convert_float2(dst_pos) + 0.5f) * convert_float2(src_size) * native_recip(dst_size);\n"
"    int2 src_pos = convert_int2(floor(src_coord - 0.5f));\n"
"\n"
"    int2 read_pos = clamp(src_pos, 0, src_size - 1);\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"    float u = read_imagef(src2, sampler2, read_pos).x;\n"
"    float v = read_imagef(src3, sampler2, read_pos).x;\n"
"#else\n"
"    float2 uv = read_imagef(src2, sampler2, read_pos).xy;\n"
"    float u = uv.x;\n"
"    float v = uv.y;\n"
"#endif\n"
"\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"    write_imagef(dst2, dst_pos, (float4)(u, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst3, dst_pos, (float4)(v, 0.0f, 0.0f, 1.0f));\n"
"#else\n"
"    write_imagef(dst2, dst_pos, (float4)(u, v, 0.0f, 1.0f));\n"
"#endif\n"
"}\n"
"#endif\n"
"\n"
"#ifdef SCALE\n"
"__kernel void scale(__write_only image2d_t dst1,\n"
"                    __read_only  image2d_t src1,\n"
"#ifdef ENABLE_DITHER\n"
"                    __read_only  image2d_t dither,\n"
"#endif\n"
"                    __constant   float    *cx,\n"
"                    __constant   float    *cy,\n"
"                                 int2      src_size)\n"
"{\n"
"    int xi = get_global_id(0);\n"
"    int yi = get_global_id(1);\n"
"\n"
"    int2 dst_pos = { xi, yi };\n"
"    float2 dst_size = { get_global_size(0), get_global_size(1) };\n"
"\n"
"    float2 src_coord = (convert_float2(dst_pos) + 0.5f) * convert_float2(src_size) * native_recip(dst_size);\n"
"    int2 src_pos = convert_int2(floor(src_coord - 0.5f));\n"
"\n"
"#ifdef ENABLE_DITHER\n"
"    float2 ncoords = convert_float2((int2)(xi, yi)) *\n"
"        native_recip((float2)(get_image_width(dither), get_image_height(dither)));\n"
"#endif\n"
"\n"
"    int i, j;\n"
"    int filterw2 = filterw >> 1;\n"
"    int filterh2 = filterh >> 1;\n"
"    int2 src_size_edge = src_size - 1;\n"
"    float4 col1 = 0.0f, s1 = 0.0f;\n"
"\n"
"#pragma unroll\n"
"    for (i = 0; i < filterh; ++i, s1 = 0.0f) {\n"
"        #pragma unroll\n"
"        for (j = 0; j < filterw; ++j) {\n"
"            int2 read_pos = clamp(src_pos + (int2)(filterw2 - j, filterh2 - i), 0, src_size_edge);\n"
"            float4 c1 = read_imagef(src1, sampler2, read_pos);\n"
"            s1 += c1 * cx[dst_pos.x * filterw + j];\n"
"        }\n"
"        col1 += s1 * cy[dst_pos.y * filterh + i];\n"
"    }\n"
"\n"
"    float y = col1.x;\n"
"#ifdef ENABLE_DITHER\n"
"    float d = read_imagef(dither, d_sampler, ncoords).x;\n"
"    y = get_dithered_y(y, d);\n"
"#endif\n"
"\n"
"    write_imagef(dst1, dst_pos, (float4)(y, 0.0f, 0.0f, 1.0f));\n"
"}\n"
"\n"
"__kernel void scale_uv(__write_only image2d_t dst2,\n"
"                       __read_only  image2d_t src2,\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"                       __write_only image2d_t dst3,\n"
"#endif\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"                       __read_only  image2d_t src3,\n"
"#endif\n"
"                       __constant   float    *cx,\n"
"                       __constant   float    *cy,\n"
"                                    int2      src_size)\n"
"{\n"
"    int2 dst_pos = { get_global_id(0), get_global_id(1) };\n"
"    float2 dst_size = { get_global_size(0), get_global_size(1) };\n"
"\n"
"    float2 src_coord = (convert_float2(dst_pos) + 0.5f) * convert_float2(src_size) * native_recip(dst_size);\n"
"    int2 src_pos = convert_int2(floor(src_coord - 0.5f));\n"
"\n"
"    int i, j;\n"
"    int filterw2 = filterw >> 1;\n"
"    int filterh2 = filterh >> 1;\n"
"    int2 src_size_edge = src_size - 1;\n"
"    float4 col2 = 0.0f, col3 = 0.0f, s2 = 0.0f, s3 = 0.0f;\n"
"\n"
"#pragma unroll\n"
"    for (i = 0; i < filterh; ++i, s2 = s3 = 0.0f) {\n"
"        #pragma unroll\n"
"        for (j = 0; j < filterw; ++j) {\n"
"            int2 read_pos = clamp(src_pos + (int2)(filterw2 - j, filterh2 - i), 0, src_size_edge);\n"
"            float4 c2 = read_imagef(src2, sampler2, read_pos);\n"
"            s2 += c2 * cx[dst_pos.x * filterw + j];\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"            float4 c3 = read_imagef(src3, sampler2, read_pos);\n"
"            s3 += c3 * cx[dst_pos.x * filterw + j];\n"
"#endif\n"
"        }\n"
"        col2 += s2 * cy[dst_pos.y * filterh + i];\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"        col3 += s3 * cy[dst_pos.y * filterh + i];\n"
"#endif\n"
"    }\n"
"\n"
"#ifdef NON_SEMI_PLANAR_IN\n"
"    float u = col2.x;\n"
"    float v = col3.x;\n"
"#else\n"
"    float u = col2.x;\n"
"    float v = col2.y;\n"
"#endif\n"
"\n"
"#ifdef NON_SEMI_PLANAR_OUT\n"
"    write_imagef(dst2, dst_pos, (float4)(u, 0.0f, 0.0f, 1.0f));\n"
"    write_imagef(dst3, dst_pos, (float4)(v, 0.0f, 0.0f, 1.0f));\n"
"#else\n"
"    write_imagef(dst2, dst_pos, (float4)(u, v, 0.0f, 1.0f));\n"
"#endif\n"
"}\n"
"#endif\n"
;
